Index: tar.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/tar.cc,v
retrieving revision 2.5
diff -u -p -r2.5 tar.cc
--- tar.cc	2001/06/13 16:11:01	2.5
+++ tar.cc	2001/11/11 06:54:58
@@ -15,268 +15,229 @@
 
 /* Built-in tar functionality.  See tar.h for usage. */
 
-static char *cvsid = "\n%%% $Id: tar.cc,v 2.5 2001/06/13 16:11:01 cgf Exp $\n";
+#if 0
+static const char *cvsid =
+  "\n%%% $Id: tar.cc,v 2.5 2001/06/13 16:11:01 cgf Exp $\n";
+#endif
 
 #include "win32.h"
 #include <stdio.h>
 #include <stdlib.h>
 #include <sys/types.h>
 #include <sys/fcntl.h>
+#include <errno.h>
 
-#include "zlib/zlib.h"
+//#include "zlib/zlib.h"
+#include "io_stream.h"
+//#include "compress.h"
+#include "archive.h"
 #include "tar.h"
 #include "mkdir.h"
 #include "log.h"
 #include "filemanip.h"
+#include "concat.h"
 
 #include "port.h"
+#if 0
 #undef _WIN32
 #include "bzlib.h"
 
 #define FACTOR (0x19db1ded53ea710LL)
 #define NSPERSEC 10000000LL
 #define SYMLINK_COOKIE "!<symlink>"
-
-typedef struct {
-  char name[100];               /*   0 */
-  char mode[8];                 /* 100 */
-  char uid[8];                  /* 108 */
-  char gid[8];                  /* 116 */
-  char size[12];                /* 124 */
-  char mtime[12];               /* 136 */
-  char chksum[8];               /* 148 */
-  char typeflag;                /* 156 */
-  char linkname[100];           /* 157 */
-  char magic[6];                /* 257 */
-  char version[2];              /* 263 */
-  char uname[32];               /* 265 */
-  char gname[32];               /* 297 */
-  char devmajor[8];             /* 329 */
-  char devminor[8];             /* 337 */
-  char prefix[155];             /* 345 */
-  char junk[12];		/* 500 */
-} tar_header_type;
-
-typedef struct tar_map_result_type_s {
-  struct tar_map_result_type_s *next;
-  char *stored_name;
-  char *mapped_name;
-} tar_map_result_type;
-
-static tar_map_result_type *tar_map_result = 0;
-
+#endif
 static int err;
 
-static char file_name[_MAX_PATH+512];
-static char have_longname = 0;
-static int  file_length;
+//static char file_name[_MAX_PATH+512];
+//static char have_longname = 0;
+//static int  file_length;
 
-static tar_header_type tar_header;
 static char buf[512];
 
-static int _tar_file_size = 0;
 int _tar_verbose = 0;
-FILE * _tar_vfile = 0;
+FILE *_tar_vfile = 0;
 #define vp if (_tar_verbose) fprintf
 #define vp2 if (_tar_verbose>1) fprintf
-
-class gzbz
-{
- protected:
-  union
-  {
-    gzFile g;
-    BZFILE *b;
-  };
-  int fd;
-public:
-  virtual int read (void *buf, int len) {};
-  virtual int close () {};
-  virtual off_t tell () {};
-  operator int () {return (int) g;}
-};
-
-class gz: public gzbz
-{
- public:
-  gz (const char *pathname)
-  {
-    g = gzopen (pathname, "rb");
-  }
-  int read (void *buf, int len)
-  {
-    return gzread (g, buf, len);
-  }
-  int close ()
-  {
-    return gzclose (g);
-  }
-  off_t tell () {return gzctell (g);}
-  ~gz () {close ();}
-};
-
-class bz: public gzbz
-{
- public:
-  bz (const char *pathname)
-  {
-    fd = open (pathname, O_RDONLY | O_BINARY);
-    if (fd)
-      b = BZ2_bzdopen (fd, "rb");
-    else
-      b = NULL;
-  }
-  int read (void *buf, int len)
-  {
-    return BZ2_bzread (b, buf, len);
-  }
-  int close ()
-  {
-    BZ2_bzclose (b);
-    return 0;
-  }
-  off_t tell () {return ::tell (fd);}
-  ~bz () {close ();}
-};
 
-gzbz *z = NULL;
-
-static char *
-xstrdup (char *c)
+archive_tar::archive_tar (io_stream * original)
 {
-  char *r = (char *) malloc (strlen (c) + 1);
-  if (!r)
-    exit_setup (1);
-  strcpy (r, c);
-  return r;
-}
-
-int
-tar_open (const char *pathname)
-{
+  archive_children = 0;
   if (_tar_vfile == 0)
     _tar_vfile = stderr;
 
-  vp2 (_tar_vfile, "tar: open `%s'\n", pathname);
-  DWORD size;
-  if ((size = get_file_size (pathname)) == 0)
-    return 1;
-  _tar_file_size = size;
-
-  if (strstr (pathname, ".bz2"))
-    z = new bz (pathname);
-  else
-    z = new gz (pathname);
-  if (sizeof (tar_header) != 512)
+  vp2 (_tar_vfile, "tar: open `%p'\n", original);
+
+  if (!original)
     {
+      state.lasterr = EBADF;
+      return;
+    }
+  state.parent = original;
+
+  if (sizeof (state.tar_header) != 512)
+    {
       /* drastic, but important */
       fprintf (stderr, "compilation error: tar header struct not 512"
-	       " bytes (it's %d)\n", sizeof (tar_header));
+	       " bytes (it's %d)\n", sizeof (state.tar_header));
       exit_setup (1);
     }
-  err = 0;
-  return *z ? 0 : 1;
 }
 
+ssize_t
+archive_tar::read (void *buffer, size_t len)
+{
+  return -1;
+}
+
+ssize_t
+archive_tar::write (void *buffer, size_t len)
+{
+  return 0;
+}
+
+ssize_t
+archive_tar::peek (void *buffer, size_t len)
+{
+  return 0;
+}
+
 int
-tar_ftell ()
+archive_tar::error ()
 {
-  return z->tell ();
+  return state.lasterr;
 }
 
-static void
-skip_file ()
+long
+archive_tar::tell ()
 {
-  while (file_length > 0)
+  return state.file_offset;
+}
+
+int
+archive_tar::skip_file ()
+{
+  while (state.file_length > state.file_offset)
     {
-      z->read (buf, 512);
-      file_length -= 512;
+      int len = state.parent->read (buf, 512);
+      state.file_offset += 512;
+      if (len != 512)
+	return 1;
     }
+  state.file_length = 0;
+  state.file_offset = 0;
+  state.header_read = 0;
+  return 0;
 }
 
-char *
-tar_next_file ()
+const char *
+archive_tar::next_file_name ()
 {
-  int r, n;
   char *c;
-  r = z->read (&tar_header, 512);
 
+  if (state.header_read)
+    if (strlen (state.filename))
+      return state.filename;
+    else
+      /* End of tar */
+      return NULL;
+
+  int r = state.parent->read (&state.tar_header, 512);
+
   /* See if we're at end of file */
   if (r != 512)
-    return 0;
+    return NULL;
 
   /* See if the header is all zeros (i.e. last block) */
-  n = 0;
-  for (r = 512/sizeof (int); r; r--)
-    n |= ((int *)&tar_header)[r-1];
+  int n = 0;
+  for (r = 512 / sizeof (int); r; r--)
+    n |= ((int *) &state.tar_header)[r - 1];
   if (n == 0)
-    return 0;
+    return NULL;
 
-  if (!have_longname && tar_header.typeflag != 'L')
+  if (!state.have_longname && state.tar_header.typeflag != 'L')
     {
-      memcpy (file_name, tar_header.name, 100);
-      file_name[100] = 0;
+      memcpy (state.filename, state.tar_header.name, 100);
+      state.filename[100] = 0;
     }
 
-  sscanf (tar_header.size, "%o", &file_length);
+  sscanf (state.tar_header.size, "%o", &state.file_length);
+  state.file_offset = 0;
 
-  vp2 (_tar_vfile, "%c %9d %s\n", tar_header.typeflag, file_length, file_name);
+//  vp2 (_tar_vfile, "%c %9d %s\n", state.tar_header.typeflag,
+//      state.file_length, state.filename);
 
-  switch (tar_header.typeflag)
+  switch (state.tar_header.typeflag)
     {
-    case 'L': /* GNU tar long name extension */
-      if (file_length > _MAX_PATH)
+    case 'L':			/* GNU tar long name extension */
+      /* we read the 'file' into the long filename, then call back into here
+       * to find out if the actual file is a real file, or a special file..
+       */
+      if (state.file_length > _MAX_PATH)
 	{
 	  skip_file ();
 	  fprintf (stderr, "error: long file name exceeds %d characters\n",
 		   _MAX_PATH);
 	  err++;
-	  z->read (&tar_header, 512);
-	  sscanf (tar_header.size, "%o", &file_length);
+	  state.parent->read (&state.tar_header, 512);
+	  sscanf (state.tar_header.size, "%o", &state.file_length);
+	  state.file_offset = 0;
 	  skip_file ();
-	  return tar_next_file ();
+	  return next_file_name ();
 	}
-      c = file_name;
-      while (file_length > 0)
+      c = state.filename;
+      /* FIXME: this should be a single read() call */
+      while (state.file_length > state.file_offset)
 	{
-	  int need = file_length > 512 ? 512 : file_length;
-	  if (z->read (buf, 512) < 512)
+	  int need =
+	    state.file_length - state.file_offset >
+	    512 ? 512 : state.file_length - state.file_offset;
+	  if (state.parent->read (buf, 512) < 512)
 	    return 0;
 	  memcpy (c, buf, need);
 	  c += need;
-	  file_length -= need;
+	  state.file_offset += need;
 	}
       *c = 0;
-      have_longname = 1;
-      return tar_next_file ();
+      state.have_longname = 1;
+      return next_file_name ();
 
-    case '3': /* char */
-    case '4': /* block */
-    case '6': /* fifo */
+    case '3':			/* char */
+    case '4':			/* block */
+    case '6':			/* fifo */
       fprintf (stderr, "warning: not extracting special file %s\n",
-	       file_name);
+	       state.filename);
       err++;
-      return tar_next_file ();
+      return next_file_name ();
 
-    case '0': /* regular file */
-    case 0: /* regular file also */
-    case '2': /* symbolic link */
-    case '5': /* directory */
-    case '7': /* contiguous file */
-      return file_name;
+    case '0':			/* regular file */
+    case 0:			/* regular file also */
+    case '2':			/* symbolic link */
+    case '5':			/* directory */
+    case '7':			/* contiguous file */
+      state.header_read = 1;
+      return state.filename;
+
+    case '1':			/* hard link, we just copy */
+      state.header_read = 1;
+      return state.filename;
 
-    case '1': /* hard link, we just copy */
-      return file_name;
-
     default:
       fprintf (stderr, "error: unknown (or unsupported) file type `%c'\n",
-	       tar_header.typeflag);
+	       state.tar_header.typeflag);
       err++;
       skip_file ();
-      return tar_next_file ();
+      return next_file_name ();
     }
+  return NULL;
+}
+
+archive_tar::~archive_tar ()
+{
+  if (state.parent)
+    delete state.parent;
 }
 
+# if 0
 static void
 fix_time_stamp (char *path)
 {
@@ -298,32 +259,8 @@ fix_time_stamp (char *path)
       CloseHandle (h);
     }
 }
-
-static FILE *
-common_fopen (char *path)
-{
-  FILE *out;
-  out = fopen (path, "wb");
-  if (!out)
-    {
-      /* maybe we need to create a directory */
-      if (mkdir_p (0, path))
-	{
-	  skip_file ();
-	  return 0;
-	}
-      out = fopen (path, "wb");
-    }
-  if (!out)
-    {
-      fprintf (stderr, "unable to write to file %s\n", path);
-      perror ("The error was");
-      skip_file ();
-      return 0;
-    }
-  return out;
-}
-
+#endif
+#if 0
 static void
 prepare_for_file (char *path)
 {
@@ -335,11 +272,14 @@ prepare_for_file (char *path)
     {
       char *tmp = (char *) malloc (strlen (path) + 10);
       int i = 0;
-      do {
-	i++;
-	sprintf (tmp, "%s.old-%d", path, i);
-      } while (GetFileAttributes (tmp) != 0xffffffff);
-      fprintf (stderr, "warning: moving directory \"%s\" out of the way.\n", path);
+      do
+	{
+	  i++;
+	  sprintf (tmp, "%s.old-%d", path, i);
+	}
+      while (GetFileAttributes (tmp) != 0xffffffff);
+      fprintf (stderr, "warning: moving directory \"%s\" out of the way.\n",
+	       path);
       MoveFile (path, tmp);
       free (tmp);
     }
@@ -347,18 +287,70 @@ prepare_for_file (char *path)
   DeleteFileA (path);
 }
 
+static char *
+xstrdup (char *c)
+{
+  char *r = (char *) malloc (strlen (c) + 1);
+  if (!r)
+    exit_setup (1);
+  strcpy (r, c);
+  return r;
+}
+#endif
+archive_file_t
+archive_tar::next_file_type ()
+{
+  switch (state.tar_header.typeflag)
+    {
+      /* regular files */
+    case '0':
+    case 0:
+    case '7':
+      return ARCHIVE_FILE_REGULAR;
+    case '1':
+      return ARCHIVE_FILE_HARDLINK;
+    case '5':
+      return ARCHIVE_FILE_DIRECTORY;
+    case '2':
+      return ARCHIVE_FILE_SYMLINK;
+    default:
+      return ARCHIVE_FILE_INVALID;
+    }
+}
+
+const char *
+archive_tar::linktarget ()
+{
+  /* TODO: consider .. path traversal issues */
+  if (next_file_type () == ARCHIVE_FILE_SYMLINK ||
+      next_file_type () == ARCHIVE_FILE_HARDLINK)
+    return state.tar_header.linkname;
+  return NULL;
+}
+
+io_stream *
+archive_tar::extract_file ()
+{
+  if (archive_children)
+    return NULL;
+  archive_tar_file *rv = new archive_tar_file (state);
+  return rv;
+}
+
+
+#if 0
 int
 tar_read_file (char *path)
 {
   FILE *out, *copy;
   HANDLE h;
-  DWORD w, startticks;
+  DWORD w;
   int got;
   tar_map_result_type *tmr;
 
   switch (tar_header.typeflag)
     {
-    case '0':	/* regular files */
+    case '0':			/* regular files */
     case 0:
     case '7':
       vp (_tar_vfile, "F %s\n", path);
@@ -374,7 +366,8 @@ tar_read_file (char *path)
 	  got = z->read (buf, 512);
 	  if (got < 512)
 	    {
-	      fprintf (stderr, "tar: unexpected end of file reading %s\n", path);
+	      fprintf (stderr, "tar: unexpected end of file reading %s\n",
+		       path);
 	      fclose (out);
 	      remove (path);
 	      return 1;
@@ -403,8 +396,8 @@ tar_read_file (char *path)
 
       return 0;
 
-    case '1':	/* hard links; we just copy */
-      for (tmr = tar_map_result; tmr; tmr=tmr->next)
+    case '1':			/* hard links; we just copy */
+      for (tmr = tar_map_result; tmr; tmr = tmr->next)
 	if (strcmp (tmr->stored_name, tar_header.linkname) == 0)
 	  break;
       if (!tmr)
@@ -443,22 +436,23 @@ tar_read_file (char *path)
       fix_time_stamp (path);
       return 0;
 
-    case '5':	/* directories */
+    case '5':			/* directories */
       vp (_tar_vfile, "D %s\n", path);
-      while (path[0] && path[strlen (path)-1] == '/')
+      while (path[0] && path[strlen (path) - 1] == '/')
 	path[strlen (path) - 1] = 0;
       return mkdir_p (1, path);
 
 
-    case '2':	/* symbolic links */
+    case '2':			/* symbolic links */
       vp (_tar_vfile, "L %s -> %s\n", path, tar_header.linkname);
       prepare_for_file (path);
       h = CreateFileA (path, GENERIC_WRITE, 0, 0, CREATE_NEW,
-		      FILE_ATTRIBUTE_NORMAL, 0);
+		       FILE_ATTRIBUTE_NORMAL, 0);
       if (h == INVALID_HANDLE_VALUE)
 	{
-	  fprintf (stderr, "error: unable to create symlink \"%s\" -> \"%s\"\n",
-		   path, tar_header.linkname);
+	  fprintf (stderr,
+		   "error: unable to create symlink \"%s\" -> \"%s\"\n", path,
+		   tar_header.linkname);
 	  return 1;
 	}
       strcpy (buf, SYMLINK_COOKIE);
@@ -473,95 +467,8 @@ tar_read_file (char *path)
       fprintf (stderr, "error: unable to write symlink \"%s\"\n", path);
       DeleteFileA (path);
       return 1;
+    default:
+      return 0;
     }
 }
-
-int
-tar_close ()
-{
-#if 0
-  while (tar_map_result)
-    {
-      tar_map_result_type *t = tar_map_result->next;
-      free (tar_map_result->stored_name);
-      free (tar_map_result->mapped_name);
-      free (tar_map_result);
-      tar_map_result = t;
-    }
 #endif
-  tar_map_result = 0;
-
-  if (z->close ())
-    err++;
-  return err; /* includes errors for skipped files, etc */
-}
-
-typedef struct {
-  char *from;
-  int from_len;
-  char *to;
-  int to_len;
-} map_type;
-
-static map_type *map;
-static int nmaps;
-
-int
-tar_auto (char *pathname, char **maplist)
-{
-  char *c;
-  int err = 0;
-  int i, j;
-  map_type mtemp;
-  char newname[_MAX_PATH+512];
-  static char twiddles[] = "|\b/\b-\b\\\b";
-  int t = 0;
-
-  for (nmaps=0; maplist[nmaps*2]; nmaps++) ;
-  map = (map_type *) malloc ((nmaps+1) * sizeof (map_type));
-  for (nmaps=0; maplist[nmaps*2]; nmaps++)
-    {
-      map[nmaps].from = maplist[nmaps*2];
-      map[nmaps].from_len = strlen (maplist[nmaps*2]);
-      map[nmaps].to = maplist[nmaps*2+1];
-      map[nmaps].to_len = strlen (maplist[nmaps*2+1]);
-    }
-  /* bubble sort - expect the maps to be short */
-  for (i=0; i<nmaps-1; i++)
-    for (j=i+1; j<nmaps; j++)
-      if (map[i].from_len < map[j].from_len)
-	{
-	  mtemp = map[i];
-	  map[i] = map[j];
-	  map[j] = mtemp;
-	}
-
-  if (tar_open (pathname))
-    return 1;
-  while (c = tar_next_file ())
-    {
-      int l = strlen (c);
-      for (i=0; i<nmaps; i++)
-	if (l >= map[i].from_len
-	    && strncmp (c, map[i].from, map[i].from_len) == 0)
-	  {
-	    strcpy (newname, map[i].to);
-	    strcpy (newname+map[i].to_len, c + map[i].from_len);
-	    c = newname;
-	    break;
-	  }
-
-      t = (t+2) % 8;
-      fwrite (twiddles+t, 1, 2, stderr);
-
-      if (tar_read_file (c))
-	err++;
-    }
-  if (tar_close ())
-    err++;
-
-  fwrite (" \b", 1, 2, stderr);
-
-  vp2 (_tar_vfile, "tar_auto returns %d\n", err);
-  return err;
-}
Index: tar.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/tar.h,v
retrieving revision 2.1
diff -u -p -r2.1 tar.h
--- tar.h	2001/06/13 16:11:01	2.1
+++ tar.h	2001/11/11 06:54:58
@@ -10,36 +10,148 @@
  *     http://www.gnu.org/
  *
  * Written by DJ Delorie <dj@cygnus.com>
+ * Made OOP by R Collins <rbtcollins@hotmail.com>
  *
  */
 
 #ifndef __TAR_H_
 #define __TAR_H_
 
+typedef struct
+{
+  char name[100];		/*   0 */
+  char mode[8];			/* 100 */
+  char uid[8];			/* 108 */
+  char gid[8];			/* 116 */
+  char size[12];		/* 124 */
+  char mtime[12];		/* 136 */
+  char chksum[8];		/* 148 */
+  char typeflag;		/* 156 */
+  char linkname[100];		/* 157 */
+  char magic[6];		/* 257 */
+  char version[2];		/* 263 */
+  char uname[32];		/* 265 */
+  char gname[32];		/* 297 */
+  char devmajor[8];		/* 329 */
+  char devminor[8];		/* 337 */
+  char prefix[155];		/* 345 */
+  char junk[12];		/* 500 */
+}
+tar_header_type;
+
+typedef struct tar_map_result_type_s
+{
+  struct tar_map_result_type_s *next;
+  char *stored_name;
+  char *mapped_name;
+}
+tar_map_result_type;
+
+class tar_state
+{
+public:
+  tar_state ():lasterr (0), eocf (0), have_longname ('\0'), file_offset (0),
+    file_length (0), header_read (0)
+  {
+    parent = NULL;
+    filename[0] = '\0';
+    tar_map_result = NULL;
+  };
+  io_stream *parent;
+  int lasterr;
+  int eocf;
+  char have_longname;
+  /* where in the current file are we? */
+  size_t file_offset;
+  size_t file_length;
+  int header_read;
+  tar_header_type tar_header;
+  char filename[_MAX_PATH + 512];
+  tar_map_result_type *tar_map_result;
+};
+
+class archive_tar_file:public io_stream
+{
+public:
+  archive_tar_file (tar_state &);
+  virtual ssize_t read (void *buffer, size_t len);
+  /* provide data to (double duh!) */
+  virtual ssize_t write (void *buffer, size_t len);
+  /* read data without removing it from the class's internal buffer */
+  virtual ssize_t peek (void *buffer, size_t len);
+  virtual long tell ();
+  /* try guessing this one */
+  virtual int error ();
+  virtual char *next_file_name ()
+  {
+    return NULL;
+  };
+  virtual int set_mtime (int)
+  {
+    return 1;
+  };
+    virtual ~ archive_tar_file ();
+private:
+    tar_state & state;
+};
+
+class archive_tar:public archive
+{
+public:
+  archive_tar (io_stream * original);
+  virtual io_stream *extract_file ();
+  /* read data (duh!) */
+  virtual ssize_t read (void *buffer, size_t len);
+  /* provide data to (double duh!) */
+  virtual ssize_t write (void *buffer, size_t len);
+  /* read data without removing it from the class's internal buffer */
+  virtual ssize_t peek (void *buffer, size_t len);
+  virtual long tell ();
+  /* try guessing this one */
+  virtual int error ();
+  /* Find out the next stream name -
+   * ie for foo.tar.gz, at offset 0, next_file_name = foo.tar
+   * for foobar that is an compress, next_file_name is the next
+   * extractable filename.
+   */
+  virtual const char *next_file_name ();
+  virtual archive_file_t next_file_type ();
+  /* only of use when we support writing to tar */
+  virtual int set_mtime (int)
+  {
+    return 1;
+  };
+  virtual const char *linktarget ();
+  virtual int skip_file ();
+  /* if you are still needing these hints... give up now! */
+    virtual ~ archive_tar ();
+private:
+    archive_tar ()
+  {
+  };
+  tar_state state;
+  unsigned int archive_children;
+};
+
 /* Only one tarfile may be open at a time.  gzipped files handled
    automatically */
 
 /* returns zero on success, nonzero on failure */
-int	tar_open (const char *pathname);
-
-/* returns pointer to static buf containing name of next file */
-char *	tar_next_file ();
+//int   tar_open (const char *pathname);
 
-/* byte position in [compressed] file */
-int	tar_ftell ();
-
 /* pass adjusted path, returns zero on success, nonzero on failure */
-int	tar_read_file (char *path);
+//int   tar_read_file (char *path);
 
-/* closes the file */
-int	tar_close ();
 
+#if 0
 /* pass path to tar file and from/to pairs for path prefix (NULLs at
    end , returns zero if completely successful, nonzero (counts
    errors) on failure */
-int	tar_auto (char *pathname, char **map);
+int tar_auto (char *pathname, char **map);
+#endif
+
 
-int	tar_mkdir_p (int isadir, char *path);
+//int   tar_mkdir_p (int isadir, char *path);
 
 /*
 extern int _tar_verbose;
